"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.filter = void 0;
const mapVector_1 = require("./mapVector");
/**
 * Make the source valueless when the current value doesn't match the given
 * filter function.
 *
 * Use with `mergeLatest` to create a source that keeps the latest matching
 * value.
 */
function filter(source, predicate) {
    return (0, mapVector_1.mapVector)(source, (vector) => vector.filter(predicate));
}
exports.filter = filter;
