"use strict";
/* eslint-disable react-hooks/rules-of-hooks */
/// <reference types="react/experimental" />
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSourceModern = void 0;
const tslib_1 = require("tslib");
const react_1 = (0, tslib_1.__importStar)(require("react"));
const source_1 = require("../source");
const { unstable_createMutableSource: createMutableSource, unstable_useMutableSource: useMutableSource, } = react_1.default;
const MissingToken = Symbol();
const subscribe = ([, subscribe], cb) => subscribe(cb);
let mutableSources;
//
// TODO
// double check that I'm not relying on a promise being thrown by getVector anywhere
//
const useSourceModern = (maybeSource, options = {}) => {
    const hasDefaultValue = 'defaultValue' in options;
    const { defaultValue, startTransition } = options;
    const [core, select] = maybeSource || source_1.nullSource;
    if (!mutableSources) {
        mutableSources = new WeakMap([
            [source_1.nullSource[0], createMutableSource(source_1.nullSource[0], source_1.nullSource[0][0])],
        ]);
    }
    const getSnapshot = (0, react_1.useCallback)((core) => {
        const snapshot = (0, source_1.hasSnapshot)([core, select])
            ? select(core[0]()[0])
            : MissingToken;
        if (snapshot === MissingToken && !hasDefaultValue) {
            throw (0, source_1.getSnapshotPromise)([core, select]);
        }
        return snapshot;
    }, [hasDefaultValue, select]);
    const subscribeWithTransition = (0, react_1.useMemo)(() => startTransition
        ? ([, subscribe], callback) => subscribe(() => {
            startTransition(callback);
        })
        : subscribe, [startTransition]);
    let mutableSource = mutableSources.get(core);
    if (!mutableSource) {
        mutableSource = createMutableSource(core, core[0]);
        mutableSources.set(core, mutableSource);
    }
    const value = useMutableSource(mutableSource, getSnapshot, subscribeWithTransition);
    return value === MissingToken || maybeSource === null ? defaultValue : value;
};
exports.useSourceModern = useSourceModern;
