"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.map = void 0;
const mapVector_1 = require("./mapVector");
/**
 * Map differs from select in that the map function will only be called
 * upon changes to the original source, and thus it is safe to create new
 * objects in the map function.
 */
function map(source, callback) {
    return (0, mapVector_1.mapVector)(source, (vector) => vector.map(callback));
}
exports.map = map;
