"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.select = void 0;
/**
 * Select differs from map, in that it is not de-duped, so you should only
 * use it to drill down into existing objects -- not to create new ones.
 *
 * Select can also be used without memoization, while map creates a new
 * underlying source core each time and thus requires memoization.
 */
function select([core, parentSelect, act], selector) {
    const select = (value) => selector(parentSelect(value));
    return [core, select, act];
}
exports.select = select;
