"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pendingSource = exports.nullSource = exports.constantVector = exports.constant = exports.identitySelector = exports.subscribe = exports.hasSnapshot = exports.getVector = exports.getSnapshotPromise = exports.getSnapshot = exports.act = void 0;
const retil_support_1 = require("retil-support");
function act(source, callback) {
    return Promise.resolve(source[2](callback));
}
exports.act = act;
function getSnapshot(source) {
    const [[getVector], select] = source;
    const vector = getVector();
    if (vector.length === 0) {
        throw getSnapshotPromise(source);
    }
    else {
        return select(vector[0]);
    }
}
exports.getSnapshot = getSnapshot;
function getSnapshotPromise([[getVector, subscribe], select,]) {
    try {
        const vector = getVector();
        if (vector.length > 0) {
            return Promise.resolve(select(vector[0]));
        }
        else {
            return new Promise((resolve, reject) => {
                let unresolved = true;
                const unsubscribe = subscribe(() => {
                    if (unresolved) {
                        unresolved = false;
                        resolve(select(getVector()[0]));
                        unsubscribe();
                    }
                }, () => {
                    if (unresolved) {
                        unresolved = false;
                        reject(new Error('Sealed with no value'));
                        unsubscribe();
                    }
                });
            });
        }
    }
    catch (error) {
        return Promise.reject(error);
    }
}
exports.getSnapshotPromise = getSnapshotPromise;
function getVector([[getVector]]) {
    return getVector();
}
exports.getVector = getVector;
function hasSnapshot([[getVector]]) {
    return getVector().length > 0;
}
exports.hasSnapshot = hasSnapshot;
function subscribe([[, subscribe]], onChange, onSeal) {
    return subscribe(onChange, onSeal);
}
exports.subscribe = subscribe;
const constantSubscribe = (_change, seal) => {
    if (seal) {
        seal();
    }
    return retil_support_1.noop;
};
const constantAct = (cb) => Promise.resolve(cb());
const identitySelector = (value) => value;
exports.identitySelector = identitySelector;
const constant = (value) => {
    const constantVector = [value];
    return [[() => constantVector, constantSubscribe], retil_support_1.identity, constantAct];
};
exports.constant = constant;
const constantVector = (value) => [
    [() => value, constantSubscribe],
    retil_support_1.identity,
    constantAct,
];
exports.constantVector = constantVector;
const nullVector = [null];
exports.nullSource = [
    [() => nullVector, constantSubscribe],
    retil_support_1.identity,
    constantAct,
];
exports.pendingSource = [
    [() => retil_support_1.emptyArray, constantSubscribe],
    retil_support_1.identity,
    constantAct,
];
