import { mapVector } from './mapVector';
/**
 * Make the source valueless when the current value doesn't match the given
 * filter function.
 *
 * Use with `mergeLatest` to create a source that keeps the latest matching
 * value.
 */
export function filter(source, predicate) {
    return mapVector(source, (vector) => vector.filter(predicate));
}
