import { Maybe } from 'retil-support';
import { Source } from './source';
export declare const FuseActSymbol: unique symbol;
export declare type FuseAct = typeof FuseActSymbol;
export declare type FusorAct = (callback: () => any) => FuseAct;
export interface FusorMemo {
    <U, V extends any[]>(callback: (...args: V) => U, args: V): U;
    <U>(callback: () => U): U;
}
export declare type FusorUse = <U, V = U>(source: Source<U>, ...defaultValues: Maybe<V>) => U | V;
export declare type Fusor<T> = (use: FusorUse, act: FusorAct, memo: FusorMemo) => T | FuseAct;
export declare type VectorFusorUse = <U, V = U>(source: Source<U>, ...defaultValues: Maybe<V>) => U[] | V[];
export declare type VectorFusor<T> = (use: VectorFusorUse, act: FusorAct, memo: FusorMemo) => T[] | FuseAct;
