import { Source } from '../source';
export interface UseSourceOptions<U> {
    defaultValue?: U;
    startTransition?: (callback: () => void) => void;
}
export interface UseMaybeSourceOptions<U> extends UseSourceOptions<U> {
    defaultValue: U;
}
export interface UseSourceFunction {
    <T, U = T>(source: Source<T>, options?: UseSourceOptions<U>): T | U;
    <U>(maybeSource: null, options: UseMaybeSourceOptions<U>): U;
    <T = null, U = T>(maybeSource: Source<T> | null, options: UseMaybeSourceOptions<U>): T | U | null;
}
