import { mapVector } from './mapVector';
/**
 * Map differs from select in that the map function will only be called
 * upon changes to the original source, and thus it is safe to create new
 * objects in the map function.
 */
export function map(source, callback) {
    return mapVector(source, (vector) => vector.map(callback));
}
