import { observe } from './observe';
/**
 * Map the underlying vector, as opposed to `map`, which maps the values inside
 * the vector.
 */
export function mapVector(source, callback) {
    const [[getVector, subscribe], select, act] = source;
    return observe((next, _error, seal) => {
        const handleChange = () => {
            next(callback(getVector().map(select)));
        };
        // Ensure we catch any events that are side effects of the initial
        // `handleChange`.
        const initialUnsubscribe = subscribe(handleChange);
        handleChange();
        // Now subscribe to to `seal()` events too -- we can't do this until we've
        // made the initial call to `handleChange()`.
        const unsubscribe = subscribe(handleChange, seal);
        initialUnsubscribe();
        return unsubscribe;
    }, act);
}
