import { observe } from './observe';
export function reduceVector(source, callback, initial = []) {
    const [[getVector, subscribe], select, act] = source;
    return observe((next, _error, seal) => {
        let vector = initial;
        const handleChange = () => {
            vector = callback(vector, getVector().map(select));
            next(vector);
        };
        // Ensure we catch any events that are side effects of the initial
        // `handleChange`.
        const initialUnsubscribe = subscribe(handleChange);
        handleChange();
        // Now subscribe to to `seal()` events too -- we can't do this until we've
        // made the initial call to `handleChange()`.
        const unsubscribe = subscribe(handleChange, seal);
        initialUnsubscribe();
        return unsubscribe;
    }, act);
}
