import { emptyArray, identity, noop } from 'retil-support';
export function act(source, callback) {
    return Promise.resolve(source[2](callback));
}
export function getSnapshot(source) {
    const [[getVector], select] = source;
    const vector = getVector();
    if (vector.length === 0) {
        throw getSnapshotPromise(source);
    }
    else {
        return select(vector[0]);
    }
}
export function getSnapshotPromise([[getVector, subscribe], select,]) {
    try {
        const vector = getVector();
        if (vector.length > 0) {
            return Promise.resolve(select(vector[0]));
        }
        else {
            return new Promise((resolve, reject) => {
                let unresolved = true;
                const unsubscribe = subscribe(() => {
                    if (unresolved) {
                        unresolved = false;
                        resolve(select(getVector()[0]));
                        unsubscribe();
                    }
                }, () => {
                    if (unresolved) {
                        unresolved = false;
                        reject(new Error('Sealed with no value'));
                        unsubscribe();
                    }
                });
            });
        }
    }
    catch (error) {
        return Promise.reject(error);
    }
}
export function getVector([[getVector]]) {
    return getVector();
}
export function hasSnapshot([[getVector]]) {
    return getVector().length > 0;
}
export function subscribe([[, subscribe]], onChange, onSeal) {
    return subscribe(onChange, onSeal);
}
const constantSubscribe = (_change, seal) => {
    if (seal) {
        seal();
    }
    return noop;
};
const constantAct = (cb) => Promise.resolve(cb());
export const identitySelector = (value) => value;
export const constant = (value) => {
    const constantVector = [value];
    return [[() => constantVector, constantSubscribe], identity, constantAct];
};
export const constantVector = (value) => [
    [() => value, constantSubscribe],
    identity,
    constantAct,
];
const nullVector = [null];
export const nullSource = [
    [() => nullVector, constantSubscribe],
    identity,
    constantAct,
];
export const pendingSource = [
    [() => emptyArray, constantSubscribe],
    identity,
    constantAct,
];
